#Setup Name
execute if score kazzxv_nm_enable kazzxv.nm_enable matches 1 if entity @s[tag=!kazzxv.named] run data merge entity @s {CustomName:'{"translate":"Primordial Blaze","color":"#ff7530","bold":true,"italic":false}'}
execute if score kazzxv_nm_enable kazzxv.nm_enable matches 1 if entity @s[tag=!kazzxv.named] run tag @s add kazzxv.named

#Setup Bossbar
execute unless entity @a[scores={kazzxv.pb_hp_bar=1..}] run tag @s remove kazzxv.pb_bossbar
execute if entity @s[tag=!kazzxv.pb_bossbar] at @s run bossbar add primordial_blaze "Primordial Blaze"
execute if entity @s[tag=!kazzxv.pb_bossbar] at @s run bossbar set minecraft:primordial_blaze color yellow
execute if entity @s[tag=!kazzxv.pb_bossbar] at @s run bossbar set minecraft:primordial_blaze style progress
execute if entity @s[tag=!kazzxv.pb_bossbar] at @s run bossbar set minecraft:primordial_blaze max 1000
execute if entity @s[tag=!kazzxv.pb_bossbar] at @s run scoreboard players set xv_primordial kazzxv.pb_health 1000
execute if entity @s[tag=!kazzxv.pb_bossbar] at @s run effect give @s instant_health 100 1 false
execute if entity @s[tag=!kazzxv.pb_bossbar] at @s run tag @s add kazzxv.pb_bossbar
execute if entity @s[tag=kazzxv.pb_bossbar] at @s run bossbar set minecraft:primordial_blaze players @a[distance=..64]

#Boss Buffs
effect give @s glowing 3 0 true
execute if score xv_primordial kazzxv.pb_health matches 501.. if entity @s[tag=!kazzxv.pb_phase2] run effect give @s resistance 3 0 true
execute if score xv_primordial kazzxv.pb_health matches ..500 if entity @s[tag=!kazzxv.pb_phase2] run effect give @s resistance 3 1 true
execute if score xv_primordial kazzxv.pb_health matches ..500 if entity @s[tag=!kazzxv.pb_phase2] run effect give @s regeneration 3 1 true
execute if score xv_primordial kazzxv.pb_health matches ..250 if entity @s[tag=!kazzxv.pb_phase2] run effect give @s regeneration 3 2 true
execute if score xv_primordial kazzxv.pb_health matches ..100 if entity @s[tag=!kazzxv.pb_phase2] run function kazzmon.extravanilla:mobs/custom_bosses/primordial_blaze_bossfight/second_phase

#Setup Attack Patterns
  #Initialize
scoreboard players set @s kazzxv.pb_atk 0

  #Chooses the optimal Attack depending on Distance
execute if entity @p[distance=..8] run scoreboard players set @s kazzxv.pb_atk 2
execute if entity @p[distance=8..] run scoreboard players set @s kazzxv.pb_atk 4
execute if entity @p[distance=24..] run scoreboard players set @s kazzxv.pb_atk 3
execute if entity @p[distance=48..] run scoreboard players set @s kazzxv.pb_atk 1

  #Randomly chooses an attack that complements the original Attack
execute if entity @p[distance=32..] if predicate kazzmon.extravanilla:10_percent run scoreboard players set @s kazzxv.pb_atk 1
execute if entity @p[distance=..12] if predicate kazzmon.extravanilla:5_percent run scoreboard players set @s kazzxv.pb_atk 2
execute if entity @p[distance=12..] if predicate kazzmon.extravanilla:10_percent run scoreboard players set @s kazzxv.pb_atk 3
execute if entity @p[distance=..8] if predicate kazzmon.extravanilla:5_percent run scoreboard players set @s kazzxv.pb_atk 4

#Attack Counter - Specifies Mode
  #Specifies Cooldown Points per Attack Mode
execute if score @s kazzxv.pb_atk matches 1 run scoreboard players add @s kazzxv.pb_mode 10
execute if score @s kazzxv.pb_atk matches 2 run scoreboard players add @s kazzxv.pb_mode 4
execute if score @s kazzxv.pb_atk matches 3 run scoreboard players add @s kazzxv.pb_mode 2
execute if score @s kazzxv.pb_atk matches 4 run scoreboard players add @s kazzxv.pb_mode 3
  #Adjusts Attack Mode depending on Cooldown Points / Health
execute if score @s kazzxv.pb_mode matches 12.. if score xv_primordial kazzxv.pb_health matches 501.. run scoreboard players set @s kazzxv.pb_mode -6
execute if score @s kazzxv.pb_mode matches 18.. if score xv_primordial kazzxv.pb_health matches ..500 run scoreboard players set @s kazzxv.pb_mode -9
execute if score @s kazzxv.pb_mode matches ..0 run scoreboard players set @s kazzxv.pb_atk 0
execute if score xv_primordial kazzxv.pb_health matches 751.. if predicate kazzmon.extravanilla:10_percent run scoreboard players set @s kazzxv.pb_atk 0
execute if score xv_primordial kazzxv.pb_health matches ..250 if predicate kazzmon.extravanilla:10_percent run scoreboard players set @s kazzxv.pb_atk 0

#Attack
  #Teleport
execute if score @s kazzxv.pb_atk matches 1 run scoreboard players set xv_primordial kazzxv.raycast 0
execute if score @s kazzxv.pb_atk matches 1 anchored eyes rotated ~ ~ run function kazzmon.extravanilla:mobs/custom_bosses/primordial_blaze_bossfight/attack/teleport
execute if score @s kazzxv.pb_atk matches 1 run playsound entity.enderman.teleport ambient @a ~ ~ ~ 3 1
execute if score @s kazzxv.pb_atk matches 1 run playsound entity.enderman.teleport ambient @a ~ ~ ~ 3 0.8
execute if score @s kazzxv.pb_atk matches 1 run playsound entity.enderman.teleport ambient @a ~ ~ ~ 3 0.5

  #Flame Circle
    #1
execute if score @s kazzxv.pb_atk matches 2 run scoreboard players set xv_primordial kazzxv.raycast 0
execute if score @s kazzxv.pb_atk matches 2 anchored feet rotated ~ 0 run function kazzmon.extravanilla:mobs/custom_bosses/primordial_blaze_bossfight/attack/flame_circle
    #2
execute if score @s kazzxv.pb_atk matches 2 run scoreboard players set xv_primordial kazzxv.raycast 0
execute if score @s kazzxv.pb_atk matches 2 anchored feet rotated ~90 0 run function kazzmon.extravanilla:mobs/custom_bosses/primordial_blaze_bossfight/attack/flame_circle
    #3
execute if score @s kazzxv.pb_atk matches 2 run scoreboard players set xv_primordial kazzxv.raycast 0
execute if score @s kazzxv.pb_atk matches 2 anchored feet rotated ~180 0 run function kazzmon.extravanilla:mobs/custom_bosses/primordial_blaze_bossfight/attack/flame_circle
    #4
execute if score @s kazzxv.pb_atk matches 2 run scoreboard players set xv_primordial kazzxv.raycast 0
execute if score @s kazzxv.pb_atk matches 2 anchored feet rotated ~-90 0 run function kazzmon.extravanilla:mobs/custom_bosses/primordial_blaze_bossfight/attack/flame_circle
    #Sound Effects
execute if score @s kazzxv.pb_atk matches 2 run playsound minecraft:entity.blaze.shoot ambient @a ~ ~ ~ 3 1.3
execute if score @s kazzxv.pb_atk matches 2 run playsound minecraft:entity.blaze.shoot ambient @a ~ ~ ~ 3 1
execute if score @s kazzxv.pb_atk matches 2 run playsound minecraft:entity.blaze.shoot ambient @a ~ ~ ~ 3 0.8
execute if score @s kazzxv.pb_atk matches 2 run playsound minecraft:entity.blaze.shoot ambient @a ~ ~ ~ 3 0.5

  #AOE Lightning
    #1
execute if score @s kazzxv.pb_atk matches 3 run scoreboard players set xv_primordial kazzxv.raycast 0
execute if score @s kazzxv.pb_atk matches 3 anchored eyes facing entity @r[distance=..48] feet run function kazzmon.extravanilla:mobs/custom_bosses/primordial_blaze_bossfight/attack/aoe_lightning
    #2
execute if score @s kazzxv.pb_atk matches 3 run scoreboard players set xv_primordial kazzxv.raycast 0
execute if score @s kazzxv.pb_atk matches 3 anchored eyes facing entity @r[distance=..48] feet run function kazzmon.extravanilla:mobs/custom_bosses/primordial_blaze_bossfight/attack/aoe_lightning
    #3
execute if score @s kazzxv.pb_atk matches 3 run scoreboard players set xv_primordial kazzxv.raycast 0
execute if score @s kazzxv.pb_atk matches 3 anchored eyes facing entity @r[distance=..48] feet run function kazzmon.extravanilla:mobs/custom_bosses/primordial_blaze_bossfight/attack/aoe_lightning
    #4
execute if score @s kazzxv.pb_atk matches 3 run scoreboard players set xv_primordial kazzxv.raycast 0
execute if score @s kazzxv.pb_atk matches 3 anchored eyes facing entity @r[distance=..48] feet run function kazzmon.extravanilla:mobs/custom_bosses/primordial_blaze_bossfight/attack/aoe_lightning
    #5
execute if score @s kazzxv.pb_atk matches 3 run scoreboard players set xv_primordial kazzxv.raycast 0
execute if score @s kazzxv.pb_atk matches 3 anchored eyes facing entity @r[distance=..48] feet run function kazzmon.extravanilla:mobs/custom_bosses/primordial_blaze_bossfight/attack/aoe_lightning
    #6
execute if score @s kazzxv.pb_atk matches 3 run scoreboard players set xv_primordial kazzxv.raycast 0
execute if score @s kazzxv.pb_atk matches 3 anchored eyes facing entity @r[distance=..48] feet run function kazzmon.extravanilla:mobs/custom_bosses/primordial_blaze_bossfight/attack/aoe_lightning
    #7
execute if score @s kazzxv.pb_atk matches 3 run scoreboard players set xv_primordial kazzxv.raycast 0
execute if score @s kazzxv.pb_atk matches 3 anchored eyes facing entity @p feet run function kazzmon.extravanilla:mobs/custom_bosses/primordial_blaze_bossfight/attack/aoe_lightning
    #Sound Effects
execute if score @s kazzxv.pb_atk matches 3 run playsound minecraft:block.respawn_anchor.deplete ambient @a ~ ~ ~ 3 1.3
execute if score @s kazzxv.pb_atk matches 3 run playsound minecraft:block.respawn_anchor.deplete ambient @a ~ ~ ~ 3 1
execute if score @s kazzxv.pb_atk matches 3 run playsound minecraft:block.respawn_anchor.deplete ambient @a ~ ~ ~ 3 0.8
execute if score @s kazzxv.pb_atk matches 3 run playsound minecraft:entity.blaze.shoot ambient @a ~ ~ ~ 3 0.8
execute if score @s kazzxv.pb_atk matches 3 run playsound minecraft:entity.blaze.shoot ambient @a ~ ~ ~ 3 0.5
execute if score @s kazzxv.pb_atk matches 3 run playsound minecraft:entity.blaze.burn ambient @a ~ ~ ~ 3 1

  #Fire Blast
    #Despawns all Fire Blast Fireballs
execute as @e[type=small_fireball,tag=kazzxv.pb_blast] run kill @s
    #1
execute if score @s kazzxv.pb_atk matches 4 run scoreboard players set xv_primordial kazzxv.raycast 0
execute if score @s kazzxv.pb_atk matches 4 anchored eyes facing entity @p feet run function kazzmon.extravanilla:mobs/custom_bosses/primordial_blaze_bossfight/attack/fire_blast
execute if score @s kazzxv.pb_atk matches 4 run summon minecraft:small_fireball ~ ~0.5 ~ {Motion:[0.0,0.0,0.0],power:[0.1,0.0,0.0],Tags:["kazzxv.pb_blast"]}
execute if score @s kazzxv.pb_atk matches 4 run summon minecraft:small_fireball ~ ~0.5 ~ {Motion:[0.0,0.0,0.0],power:[0.1,0.0,0.1],Tags:["kazzxv.pb_blast"]}
execute if score @s kazzxv.pb_atk matches 4 run summon minecraft:small_fireball ~ ~0.5 ~ {Motion:[0.0,0.0,0.0],power:[0.0,0.0,0.1],Tags:["kazzxv.pb_blast"]}
execute if score @s kazzxv.pb_atk matches 4 run summon minecraft:small_fireball ~ ~0.5 ~ {Motion:[0.0,0.0,0.0],power:[-0.1,0.0,0.1],Tags:["kazzxv.pb_blast"]}
execute if score @s kazzxv.pb_atk matches 4 run summon minecraft:small_fireball ~ ~0.5 ~ {Motion:[0.0,0.0,0.0],power:[-0.1,0.0,0.0],Tags:["kazzxv.pb_blast"]}
execute if score @s kazzxv.pb_atk matches 4 run summon minecraft:small_fireball ~ ~0.5 ~ {Motion:[0.0,0.0,0.0],power:[-0.1,0.0,-0.1],Tags:["kazzxv.pb_blast"]}
execute if score @s kazzxv.pb_atk matches 4 run summon minecraft:small_fireball ~ ~0.5 ~ {Motion:[0.0,0.0,0.0],power:[0.0,0.0,-0.1],Tags:["kazzxv.pb_blast"]}
execute if score @s kazzxv.pb_atk matches 4 run summon minecraft:small_fireball ~ ~0.5 ~ {Motion:[0.0,0.0,0.0],power:[0.1,0.0,-0.1],Tags:["kazzxv.pb_blast"]}
    #2
execute if score @s kazzxv.pb_atk matches 4 run scoreboard players set xv_primordial kazzxv.raycast 0
execute if score @s kazzxv.pb_atk matches 4 anchored eyes facing entity @p feet rotated ~8.0 ~ run function kazzmon.extravanilla:mobs/custom_bosses/primordial_blaze_bossfight/attack/fire_blast
execute if score @s kazzxv.pb_atk matches 4 run summon minecraft:small_fireball ~ ~0.5 ~ {Motion:[0.0,0.0,0.0],power:[0.2,0.1,0.0],Tags:["kazzxv.pb_blast"]}
execute if score @s kazzxv.pb_atk matches 4 run summon minecraft:small_fireball ~ ~0.5 ~ {Motion:[0.0,0.0,0.0],power:[0.2,0.1,0.2],Tags:["kazzxv.pb_blast"]}
execute if score @s kazzxv.pb_atk matches 4 run summon minecraft:small_fireball ~ ~0.5 ~ {Motion:[0.0,0.0,0.0],power:[0.0,0.1,0.2],Tags:["kazzxv.pb_blast"]}
execute if score @s kazzxv.pb_atk matches 4 run summon minecraft:small_fireball ~ ~0.5 ~ {Motion:[0.0,0.0,0.0],power:[-0.2,0.1,0.2],Tags:["kazzxv.pb_blast"]}
execute if score @s kazzxv.pb_atk matches 4 run summon minecraft:small_fireball ~ ~0.5 ~ {Motion:[0.0,0.0,0.0],power:[-0.2,0.1,0.0],Tags:["kazzxv.pb_blast"]}
execute if score @s kazzxv.pb_atk matches 4 run summon minecraft:small_fireball ~ ~0.5 ~ {Motion:[0.0,0.0,0.0],power:[-0.2,0.1,-0.2],Tags:["kazzxv.pb_blast"]}
execute if score @s kazzxv.pb_atk matches 4 run summon minecraft:small_fireball ~ ~0.5 ~ {Motion:[0.0,0.0,0.0],power:[0.0,0.1,-0.2],Tags:["kazzxv.pb_blast"]}
execute if score @s kazzxv.pb_atk matches 4 run summon minecraft:small_fireball ~ ~0.5 ~ {Motion:[0.0,0.0,0.0],power:[0.2,0.1,-0.2],Tags:["kazzxv.pb_blast"]}
    #3
execute if score @s kazzxv.pb_atk matches 4 run scoreboard players set xv_primordial kazzxv.raycast 0
execute if score @s kazzxv.pb_atk matches 4 anchored eyes facing entity @p feet rotated ~-8.0 ~ run function kazzmon.extravanilla:mobs/custom_bosses/primordial_blaze_bossfight/attack/fire_blast
execute if score @s kazzxv.pb_atk matches 4 run summon minecraft:small_fireball ~ ~0.5 ~ {Motion:[0.0,0.0,0.0],power:[0.3,-0.1,0.0],Tags:["kazzxv.pb_blast"]}
execute if score @s kazzxv.pb_atk matches 4 run summon minecraft:small_fireball ~ ~0.5 ~ {Motion:[0.0,0.0,0.0],power:[0.3,-0.1,0.3],Tags:["kazzxv.pb_blast"]}
execute if score @s kazzxv.pb_atk matches 4 run summon minecraft:small_fireball ~ ~0.5 ~ {Motion:[0.0,0.0,0.0],power:[0.0,-0.1,0.3],Tags:["kazzxv.pb_blast"]}
execute if score @s kazzxv.pb_atk matches 4 run summon minecraft:small_fireball ~ ~0.5 ~ {Motion:[0.0,0.0,0.0],power:[-0.3,-0.1,0.3],Tags:["kazzxv.pb_blast"]}
execute if score @s kazzxv.pb_atk matches 4 run summon minecraft:small_fireball ~ ~0.5 ~ {Motion:[0.0,0.0,0.0],power:[-0.3,-0.1,0.0],Tags:["kazzxv.pb_blast"]}
execute if score @s kazzxv.pb_atk matches 4 run summon minecraft:small_fireball ~ ~0.5 ~ {Motion:[0.0,0.0,0.0],power:[-0.3,-0.1,-0.3],Tags:["kazzxv.pb_blast"]}
execute if score @s kazzxv.pb_atk matches 4 run summon minecraft:small_fireball ~ ~0.5 ~ {Motion:[0.0,0.0,0.0],power:[0.0,-0.1,-0.3],Tags:["kazzxv.pb_blast"]}
execute if score @s kazzxv.pb_atk matches 4 run summon minecraft:small_fireball ~ ~0.5 ~ {Motion:[0.0,0.0,0.0],power:[0.3,-0.1,-0.3],Tags:["kazzxv.pb_blast"]}
    #Sound Effects
execute if score @s kazzxv.pb_atk matches 4 run playsound minecraft:entity.blaze.shoot ambient @a ~ ~ ~ 3 1.3
execute if score @s kazzxv.pb_atk matches 4 run playsound minecraft:entity.blaze.shoot ambient @a ~ ~ ~ 3 1
execute if score @s kazzxv.pb_atk matches 4 run playsound minecraft:entity.blaze.shoot ambient @a ~ ~ ~ 3 0.8
execute if score @s kazzxv.pb_atk matches 4 run playsound minecraft:entity.blaze.shoot ambient @a ~ ~ ~ 3 0.5
execute if score @s kazzxv.pb_atk matches 4 run playsound minecraft:entity.blaze.burn ambient @a ~ ~ ~ 3 1

  #Disorient
execute unless score @s kazzxv.pb_atk matches 0 if predicate kazzmon.extravanilla:10_percent as @a[distance=..64,gamemode=!creative,gamemode=!spectator] at @s run function kazzmon.extravanilla:mobs/custom_bosses/primordial_blaze_bossfight/attack/disorient

#Removes Tags on all hit mobs
tag @e remove kazzxv.boss_hit